<?php
class Especialidades extends MY_Controller
{
	
function __construct(){
	parent::__construct();
	$this->load->model('specialities_model');
}

function index(){
	$this->lista();
	}

function acceso_restringido() {
	$data['content']='acceso_restringido';
	$this->load->view('v_content',$data);
}

function check_access () {
	$this->load->library('sec_validation');	
	$result = $this->sec_validation->login_check_access($this->session->userdata('usuario_id'),$this->router->fetch_class(),$this->router->fetch_method());
	if (!$result) {
	$this->session->set_flashdata('message_error', 'Acceso Restringido=>'.$this->router->fetch_class()."/".$this->router->fetch_method());
	redirect('usuarios/acceso_restringido');
	}
}

function lista(){
	// Valida Acceso
	$this->check_access();
	
	$data['especialidades'] = $this->specialities_model->get_specialities();	
	$data['content']='admin/especialidades/lista';
	$this->load->view('v_content',$data);
	
	}

function ver($id= null){
	// Valida Acceso
	$this->check_access();

	// Sin parametro 
	if (is_null($id)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_especialidades_msg_noexiste'));
		redirect('especialidades/lista');		
	  }
	  
	$especialidad = $this->specialities_model->get_speciality($id);
	// No existe
	if (empty($especialidad)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_especialidades_msg_noexiste'));
		redirect('especialidades/lista');		
	  }
	$data['especialidad'] = $especialidad;
	$data['logs'] = $this->specialities_model->get_speciality_log($id);		
	$data['content']='admin/especialidades/ver';
	$this->load->view('v_content',$data);

	}	


	function editar($id= null,$origen="lista"){
	// Valida Acceso
	$this->check_access();

	// Sin parametro 
	if (is_null($id)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_especialidades_msg_noexiste'));
		redirect('especialidades/lista');		
	  }

	$especialidad = $this->specialities_model->get_speciality($id);
	// No existe
	if (empty($especialidad)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_especialidades_msg_noexiste'));
		redirect('especialidades/lista');		
	  }
	  
	$this->load->library('form_validation');

   if(isset($_POST["cancelar"])) {
		$this->session->set_flashdata('message', $this->lang->line('eap_especialidades_msg_cancelado'));
		if ($origen=="ver") { redirect('especialidades/ver/'.$id);} else {redirect('especialidades/lista');}
   }
			
	if (!empty($_POST))
	{    
		$this->form_validation->set_rules('nombre', 'lang:eap_especialidades_nombre', 'required|trim|max_length[20]|xss_clean|callback_validar_unico['.$id.']');     
	
		$this->form_validation->run();
	}
	
   if($this->form_validation->run()){

		$historial='';

		$data['fecha'] = date("Y-m-d H:i:s");
		if($this->input->post('nombre') != $especialidad['nombre']) {$data['nombre'] = $this->input->post('nombre');$historial.="Nombre@@$especialidad[nombre]@@$data[nombre]||";}
		
		if ($this->specialities_model->set_speciality($id, $data)){
			// GUARDA LOG
			$data_log = array(
				'id_especialidades' => $id,
				'fecha' => date("Y-m-d H:i:s"), 
				'modificador' => $this->session->userdata('usuario_nombre_apellido'),	
				'modificaciones' => $historial);
			$this->specialities_model->set_speciality_log($data_log);			
			$this->session->set_flashdata('message', $this->lang->line('eap_especialidades_msg_guardado'));
			if ($origen=="ver") { redirect('especialidades/ver/'.$id);} else {redirect('especialidades/lista');}
			//echo $this->db->last_query();
		} else {
			$this->session->set_flashdata('message', $this->lang->line('eap_especialidades_msg_guardado_error'));	
		}
   }
	

	$data['origen']= $origen;
	$data['especialidad'] = $especialidad;
	$data['logs'] = $this->specialities_model->get_speciality_log($id);	
	$data['content']='admin/especialidades/editar';
	$this->load->view('v_content',$data);

	}

function nuevo(){
	// Valida Acceso
	$this->check_access();

	$this->load->library('form_validation');

   if(isset($_POST["cancelar"])) {
		$this->session->set_flashdata('message', $this->lang->line('eap_especialidades_msg_cancelado_nuevo'));
		redirect('especialidades/lista');
   }
			
	if (!empty($_POST))
	{    
		$this->form_validation->set_rules('nombre', 'lang:eap_especialidades_nombre', 'required|trim|max_length[20]|xss_clean|callback_validar_unico');     
		$this->form_validation->run();
	}
	
   if($this->form_validation->run()){
		$historial='';
		$data['fecha'] = date("Y-m-d H:i:s");
		if($this->input->post('nombre') != "") {$data['nombre'] = $this->input->post('nombre');$historial.="Nombre@@@@$data[nombre]||";}

		$id=$this->specialities_model->set_speciality('', $data,'insert');
		
		if (is_numeric($id)){
			// Guardar LOG de Modificacion
			$data_log = array(
				'id_especialidades' => $id,
				'fecha' => date("Y-m-d H:i:s"), 
				'modificador' => $this->session->userdata('usuario_nombre_apellido'),	
				'modificaciones' => $historial);
			$this->specialities_model->set_speciality_log($data_log);
			
			$this->session->set_flashdata('message', $this->lang->line('eap_especialidades_msg_guardado'));
			redirect('especialidades/ver/'.$id);
			//echo $this->db->last_query();
		} else {
			$this->session->set_flashdata('message', $this->lang->line('eap_especialidades_msg_guardado_error'));	
		}
   }
	

	$especialidad = array(
		'nombre'=>'',
		'descripcion'=>'');

	$data['especialidad'] = $especialidad;
	$data['content']='admin/especialidades/nuevo';
	$this->load->view('v_content',$data);
	
	}	

function validar_unico ($nombre=null,$id=null){
   if ($this->specialities_model->is_unique($nombre,$id)) {
	   return TRUE;
   } else {
	   $this->form_validation->set_message('validar_unico', $this->lang->line('eap_especialidades_msg_validar_unico').'==>'.$nombre.'ID=>'.$id);
	   return FALSE;
   }
}

function borrar ($id=null){
	// Valida Acceso
	$this->check_access();
	
	if (is_null($id)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_especialidades_msg_guardado_estado_error'));
		redirect('especialidades/lista');	
	}

	$this->session->set_flashdata('message', $this->lang->line('eap_especialidades_msg_borrado'));
	if (!$this->specialities_model->delete_speciality($id)) { $this->session->set_flashdata('message', $this->lang->line('eap_especialidades_msg_guardado_estado_error')); }
	redirect('especialidades/lista');	


}
	
}


